#
# Unit Stats Mod
# CvJUnitStatsEventManager
# by Jeckel
# 
# 

from CvPythonExtensions import *
import CvUtil
import sys

import CvEventManager
import CvConfigParser
import CvPath

import JUtils

# Import all the StatsData files
import PhysicalStatsData
import MentalStatsData
import SocialStatsData

############################################################################

import CvJDataStorageUtils

# CvJDataStorageUtils.initTypesDict(pUnit, dictInit=None)
# CvJDataStorageUtils.initTypeStatsDict(pUnit, xType)
# CvJDataStorageUtils.hasTypesDict(pUnit)
# CvJDataStorageUtils.hasTypeStatsDict(pUnit, xType)
# CvJDataStorageUtils.hasTypeStat(pUnit, xType, xStat)
# CvJDataStorageUtils.setTypeStatsDict(pUnit, xType, dictStats=None)
# CvJDataStorageUtils.setTypeStat(pUnit, xType, xStat, xStatValue=None)
# CvJDataStorageUtils.delTypesDict(pUnit)
# CvJDataStorageUtils.delTypeStatsDict(pUnit, xType)
# CvJDataStorageUtils.delTypeStat(pUnit, xType, xStat)
# CvJDataStorageUtils.getDataIDStr(pObj=None)
# CvJDataStorageUtils.getUnitStatsStrType_StrStatList(pUnit, strDelim="_", bStatsTypeFirst=True)
# CvJDataStorageUtils.getTypesDict(pUnit)
# CvJDataStorageUtils.getTypeStatsDict(pUnit, xType)
# CvJDataStorageUtils.getTypeStat(pUnit, xType, xStat)

# JDataStorageUtils.initGlobalDict()
# JDataStorageUtils.hasGlobalDict()
# JDataStorageUtils.hasGlobalData(xKey)
# JDataStorageUtils.setGlobalData(xKey, xValue)
# JDataStorageUtils.getGlobalData(xKey=None)

############################################################################
# globals

gc = CyGlobalContext()

# Register the StatsData files by putting their name as a string.
listStatsDataFiles = ["PhysicalStatsData", "MentalStatsData", "SocialStatsData"]



############################################################################

#[JUnitStats Mod]

# This option allows you to turn this mod on/off.
# True - This will activate the JFort Mod.
# False - This will deactivate the JFort Mod.
# Default = True
#g_bJUnitStatsFeaturesEnabled = True

#########################################################################

#def loadConfigurationData():
	#global g_bJUnitStatsFeaturesEnabled

        # Load the JUnitStats Mod Config INI file containing all of the configuration information
	#config = CvConfigParser.CvConfigParser("JUnitStats Mod Config.ini")

	# If the JUnitStats Mod's config.ini file was found then load its values
	#if(config != None):
                #g_bJUnitStatsFeaturesEnabled = config.getboolean("JUnitStats Mod", "JUnitStats Features Enabled", True)

class CvJUnitStatsEventManager:
	def __init__(self, eventManager):
                # initialize base class

                #eventManager.addEventHandler("unitMove", self.onUnitMove)
                eventManager.addEventHandler("unitCreated", self.onUnitCreated)

        def getRoll(self, statsFile, strStat, pUnit):

                try:
                        strMethod = str(statsFile) + "." + str(strStat)
                        evalMethod = eval(strMethod)
                        iRoll = evalMethod(pUnit)
                        return iRoll
                except NameError:
                        try:
                                strMethod = str(statsFile) + ".default"
                                evalMethod = eval(strMethod)
                                iRoll = evalMethod(pUnit)
                                return iRoll
                        except:
                                return 0

	def onUnitMove(self, argsList):
		'unit move'
		pPlot,pUnit = argsList

		loadConfigurationData()

                if (g_bJUnitStatsFeaturesEnabled):
                        dictTypes = CvJDataStorageUtils.getTypesDict(pUnit)
                        #JUtils.alertDebug(0, "", )
                        JUtils.alertDebug(0, "dictTypes", dictTypes)


        def onUnitCreated(self, argsList):
		'Unit Completed'
		pUnit = argsList[0]

		global listStatsDataFiles

		#loadConfigurationData()

		if (not CvJDataStorageUtils.hasTypesDict(pUnit)):
                        CvJDataStorageUtils.initTypesDict(pUnit)

                for strFile in listStatsDataFiles:
                        evalFile = eval(strFile)
                        dictTypes = evalFile.TypesDict
                        for strType in dictTypes:
                                CvJDataStorageUtils.initTypeStatsDict(pUnit, strType)
                                dictStats = dictTypes[strType]
                                for strStat in dictStats:
                                        iValue = evalFile.getRoll(strStat, pUnit)
                                        CvJDataStorageUtils.setTypeStat(pUnit, strType, strStat, iValue)
                































